summarylogtreecommitdiffstats
path: root/pgo.sh.in
diff options
context:
space:
mode:
Diffstat (limited to 'pgo.sh.in')
-rw-r--r--pgo.sh.in54
1 files changed, 54 insertions, 0 deletions
diff --git a/pgo.sh.in b/pgo.sh.in
new file mode 100644
index 000000000000..496043b295a6
--- /dev/null
+++ b/pgo.sh.in
@@ -0,0 +1,54 @@
+#!/usr/bin/bash
+#
+# pgo.sh - Compile with, or utilize profile guided optimization
+#
+# Copyright (c) 2008-2016 Pacman Development Team <pacman-dev@archlinux.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+[[ -n "$LIBMAKEPKG_PGO_SH" ]] && return
+LIBMAKEPKG_PGO_SH=1
+
+LIBRARY=${LIBRARY:-'@libmakepkgdir@'}
+
+source "$LIBRARY/util/message.sh"
+source "$LIBRARY/util/option.sh"
+
+extra_buildopts+=('pgo')
+
+[[ -n ${PROFDEST} ]] && _PROFDEST=$(canonicalize_path ${PROFDEST})
+PROFDEST=${_PROFDEST:-$PROFDEST}
+PROFDEST=${PROFDEST:-$startdir} #default to $startdir if undefined
+if [[ ! -w $PROFDEST ]] ; then
+ error "$(gettext "You do not have write permission to store profiles in %s.")" "$PROFDEST"
+ plain "$(gettext "Aborting...")"
+ exit 1
+fi
+
+pgo() {
+ [[ "$INFAKEROOT" == 1 ]] && return
+ if check_buildoption "pgo" "y"; then
+ if [ ! -d "$PROFDEST/$pkgbase.gen" ]; then
+ mkdir "$PROFDEST/$pkgbase.gen"
+ CFLAGS+=" -fprofile-generate -fprofile-dir=$PROFDEST/$pkgbase.gen"
+ CXXFLAGS+=" -fprofile-generate -fprofile-dir=$PROFDEST/$pkgbase.gen"
+ LDFLAGS+=" -lgcov"
+ else
+ [[ ! -d "$PROFDEST/$pkgbase.used" ]] && mv "$PROFDEST/$pkgbase.gen" "$PROFDEST/$pkgbase.used"
+ CFLAGS+=" -fprofile-correction -fprofile-use -fprofile-dir=$PROFDEST/$pkgbase.used"
+ CXXFLAGS+=" -fprofile-correction -fprofile-use -fprofile-dir=$PROFDEST/$pkgbase.used"
+ fi
+ fi
+}